//
//  ViewController.m
//  testDemo
//
//  Created by ygkj on 16/10/24.
//  Copyright © 2016年 ygkj. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    
    
    [super viewDidLoad];
    
    
    [self.view addSubview:self.textfiled];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardDidShow:) name:UIKeyboardDidShowNotification object:nil];
    
    
    self.numberArray = [@[@"1", @"2", @"3", @"-",@"4", @"5", @"6",@"_", @"7", @"8", @"9",@"删除", @",", @"0", @".",@"完成"] mutableCopy];

}




- (void)keyboardDidShow:(NSNotification *)notification{
    
    UIView *keyboardView = [self getKeyboardView];
    
    [keyboardView addSubview:self.KeyView];
    [self.KeyView addSubview:self.CancelBtn];
    
    self.KeyView.frame = keyboardView.frame;
    self.KeyView.backgroundColor = [UIColor lightGrayColor];
    
    [self setUpMyKeyBoard];

    
}
#pragma mark -自定义控件布局
- (void)setUpMyKeyBoard
{
    NSInteger index = 0;
    for (NSInteger i = 0; i < 4; i++) {
        for (NSInteger j = 0; j < 4; j++) {
            UIButton *numberBtn = [UIButton buttonWithType:UIButtonTypeCustom];
            numberBtn.frame = CGRectMake([UIScreen mainScreen].bounds.size.width/4*j, self.KeyView.frame.size.height/4*i, [UIScreen mainScreen].bounds.size.width/4, self.KeyView.frame.size.height/4);
            [numberBtn setTitle:_numberArray[index] forState:UIControlStateNormal];
            numberBtn.titleLabel.textAlignment = NSTextAlignmentCenter;
            numberBtn.tag = 1000+index;
            [numberBtn setTitleColor:[UIColor redColor] forState:UIControlStateHighlighted];
            [numberBtn setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
            numberBtn.backgroundColor =[UIColor lightGrayColor];
            [numberBtn addTarget:self action:@selector(clickAction:) forControlEvents:UIControlEventTouchUpInside];
            [self.KeyView addSubview:numberBtn];
            
            index++;
        }
        
    }
}


//按钮的点击事件
- (void)clickAction:(UIButton *)sender{
    
    [sender setHighlighted:YES];
    if (!(sender.tag == 1015 || sender.tag == 1011)) {
        self.textfiled.text = [NSString stringWithFormat:@"%@%@", self.textfiled.text, sender.titleLabel.text];
    }else{
        if (sender.tag == 1015) {

            [self.textfiled resignFirstResponder];
            
        }else{
            //删除事件
            if ([self.textfiled.text length] != 0) {
                self.textfiled.text = [self.textfiled.text substringToIndex:([self.textfiled.text length] - 1)];
            }
        }
    }

}

#pragma mark -点击空白处屏幕消失
-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [self.textfiled resignFirstResponder];
}



#pragma mark -拿到键盘的view的方法

- (UIView *)getKeyboardView
{
    UIView *keyboardView = nil;
    NSArray *windows = [[UIApplication sharedApplication] windows];
    for (UIWindow *window in [windows reverseObjectEnumerator])//逆序效率更高，因为键盘总在上方
    {
        keyboardView = [self findKeyboardInView:window];
        if (keyboardView)
        {
            return keyboardView;
        }
    }
    return nil;
}
- (UIView *)findKeyboardInView:(UIView *)view
{
    for (UIView *subView in [view subviews])
    {
        if (strstr(object_getClassName(subView), "UIKeyboard"))
        {
            return subView;
        }
        else
        {
            UIView *tempView = [self findKeyboardInView:subView];
            if (tempView)
            {
                return tempView;
            }
        }
    }
    return nil;
}


#pragma mark - 懒加载
-(UITextField *)textfiled{
    
    if (_textfiled ==nil) {
        
        _textfiled =[[UITextField alloc]initWithFrame:CGRectMake(0, 100, 100, 50)];
        _textfiled.placeholder = @"输入内容";
    }
    
    return _textfiled;
}

-(UIView *)KeyView{
    
    if (_KeyView ==nil) {
        
        _KeyView = [[UIView alloc]init];
        
    }
    return _KeyView;
}
-(UIButton *)CancelBtn{
    if (_CancelBtn ==nil) {
        
        _CancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    }
    
    return _CancelBtn;
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
